package cn.com.qmth.examcloud.core.examwork.service.cache;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.examwork.service.ExamService;
import cn.com.qmth.examcloud.support.cache.bean.ExamPropertyCacheBean;
import cn.com.qmth.examcloud.web.cache.RandomObjectRedisCache;

@Service
public class ExamPropertyCache extends RandomObjectRedisCache<ExamPropertyCacheBean> {

	@Autowired
	private ExamService examService;

	@Override
	public ExamPropertyCacheBean loadFromResource(Object... keys) {
		Long examId = (Long) keys[0];
		String key = (String) keys[1];

		String value = examService.getExamProperty(examId, key);

		ExamPropertyCacheBean b = new ExamPropertyCacheBean();
		b.setExamId(examId);
		b.setKey(key);
		b.setValue(value);
		return b;
	}

	@Override
	protected String getKeyPrefix() {
		return "E_EXAM_PROP:";
	}

	@Override
	protected int getTimeout() {
		// 2分钟
		return 60 * 2;
	}

}
